/* file-clipboard-item.c generated by valac 0.32.1, the Vala compiler
 * generated from file-clipboard-item.vala, do not modify */

/*
 * Diodon - GTK+ clipboard manager.
 * Copyright (C) 2011 Diodon Team <diodon-team@lists.launchpad.net>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
 * License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *  Oliver Sauder <os@esite.ch>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <gdk/gdk.h>


#define DIODON_TYPE_ICLIPBOARD_ITEM (diodon_iclipboard_item_get_type ())
#define DIODON_ICLIPBOARD_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIODON_TYPE_ICLIPBOARD_ITEM, DiodonIClipboardItem))
#define DIODON_IS_ICLIPBOARD_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIODON_TYPE_ICLIPBOARD_ITEM))
#define DIODON_ICLIPBOARD_ITEM_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DIODON_TYPE_ICLIPBOARD_ITEM, DiodonIClipboardItemIface))

typedef struct _DiodonIClipboardItem DiodonIClipboardItem;
typedef struct _DiodonIClipboardItemIface DiodonIClipboardItemIface;

#define DIODON_TYPE_CLIPBOARD_TYPE (diodon_clipboard_type_get_type ())

#define DIODON_TYPE_CLIPBOARD_CATEGORY (diodon_clipboard_category_get_type ())

#define DIODON_TYPE_FILE_CLIPBOARD_ITEM (diodon_file_clipboard_item_get_type ())
#define DIODON_FILE_CLIPBOARD_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIODON_TYPE_FILE_CLIPBOARD_ITEM, DiodonFileClipboardItem))
#define DIODON_FILE_CLIPBOARD_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIODON_TYPE_FILE_CLIPBOARD_ITEM, DiodonFileClipboardItemClass))
#define DIODON_IS_FILE_CLIPBOARD_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIODON_TYPE_FILE_CLIPBOARD_ITEM))
#define DIODON_IS_FILE_CLIPBOARD_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIODON_TYPE_FILE_CLIPBOARD_ITEM))
#define DIODON_FILE_CLIPBOARD_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIODON_TYPE_FILE_CLIPBOARD_ITEM, DiodonFileClipboardItemClass))

typedef struct _DiodonFileClipboardItem DiodonFileClipboardItem;
typedef struct _DiodonFileClipboardItemClass DiodonFileClipboardItemClass;
typedef struct _DiodonFileClipboardItemPrivate DiodonFileClipboardItemPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _gtk_target_list_unref0(var) ((var == NULL) ? NULL : (var = (gtk_target_list_unref (var), NULL)))

typedef enum  {
	DIODON_CLIPBOARD_TYPE_NONE,
	DIODON_CLIPBOARD_TYPE_CLIPBOARD,
	DIODON_CLIPBOARD_TYPE_PRIMARY
} DiodonClipboardType;

typedef enum  {
	DIODON_CLIPBOARD_CATEGORY_CLIPBOARD = 0,
	DIODON_CLIPBOARD_CATEGORY_TEXT,
	DIODON_CLIPBOARD_CATEGORY_FILES,
	DIODON_CLIPBOARD_CATEGORY_IMAGES
} DiodonClipboardCategory;

struct _DiodonIClipboardItemIface {
	GTypeInterface parent_iface;
	DiodonClipboardType (*get_clipboard_type) (DiodonIClipboardItem* self);
	gchar* (*get_label) (DiodonIClipboardItem* self);
	gchar* (*get_mime_type) (DiodonIClipboardItem* self);
	DiodonClipboardCategory (*get_category) (DiodonIClipboardItem* self);
	GtkImage* (*get_image) (DiodonIClipboardItem* self);
	GIcon* (*get_icon) (DiodonIClipboardItem* self);
	GByteArray* (*get_payload) (DiodonIClipboardItem* self, GError** error);
	GDateTime* (*get_date_copied) (DiodonIClipboardItem* self);
	gchar* (*get_text) (DiodonIClipboardItem* self);
	gchar* (*get_checksum) (DiodonIClipboardItem* self);
	gchar* (*get_origin) (DiodonIClipboardItem* self);
	void (*to_clipboard) (DiodonIClipboardItem* self, GtkClipboard* clipboard);
	gboolean (*equals) (DiodonIClipboardItem* self, DiodonIClipboardItem* item);
	guint (*hash) (DiodonIClipboardItem* self);
};

struct _DiodonFileClipboardItem {
	GObject parent_instance;
	DiodonFileClipboardItemPrivate * priv;
};

struct _DiodonFileClipboardItemClass {
	GObjectClass parent_class;
};

struct _DiodonFileClipboardItemPrivate {
	gchar* _paths;
	gchar* _origin;
	DiodonClipboardType _clipboard_type;
	GDateTime* _date_copied;
};


static gpointer diodon_file_clipboard_item_parent_class = NULL;
static GdkAtom diodon_file_clipboard_item_copy_files;
static GdkAtom diodon_file_clipboard_item_copy_files = 0U;
static DiodonIClipboardItemIface* diodon_file_clipboard_item_diodon_iclipboard_item_parent_iface = NULL;

GType diodon_clipboard_type_get_type (void) G_GNUC_CONST;
GType diodon_clipboard_category_get_type (void) G_GNUC_CONST;
GType diodon_iclipboard_item_get_type (void) G_GNUC_CONST;
GType diodon_file_clipboard_item_get_type (void) G_GNUC_CONST;
#define DIODON_FILE_CLIPBOARD_ITEM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIODON_TYPE_FILE_CLIPBOARD_ITEM, DiodonFileClipboardItemPrivate))
enum  {
	DIODON_FILE_CLIPBOARD_ITEM_DUMMY_PROPERTY
};
DiodonFileClipboardItem* diodon_file_clipboard_item_new (DiodonClipboardType clipboard_type, const gchar* data, const gchar* origin, GDateTime* date_copied, GError** error);
DiodonFileClipboardItem* diodon_file_clipboard_item_construct (GType object_type, DiodonClipboardType clipboard_type, const gchar* data, const gchar* origin, GDateTime* date_copied, GError** error);
static gchar** diodon_file_clipboard_item_convert_to_paths (const gchar* paths, int* result_length1);
static DiodonClipboardType diodon_file_clipboard_item_real_get_clipboard_type (DiodonIClipboardItem* base);
static GDateTime* diodon_file_clipboard_item_real_get_date_copied (DiodonIClipboardItem* base);
static gchar* diodon_file_clipboard_item_real_get_text (DiodonIClipboardItem* base);
static gchar* diodon_file_clipboard_item_real_get_origin (DiodonIClipboardItem* base);
static gchar* diodon_file_clipboard_item_real_get_label (DiodonIClipboardItem* base);
static gchar* diodon_file_clipboard_item_real_get_mime_type (DiodonIClipboardItem* base);
static gchar** diodon_file_clipboard_item_convert_to_uris (const gchar* paths, int* result_length1);
static DiodonClipboardCategory diodon_file_clipboard_item_real_get_category (DiodonIClipboardItem* base);
static GtkImage* diodon_file_clipboard_item_real_get_image (DiodonIClipboardItem* base);
GIcon* diodon_iclipboard_item_get_icon (DiodonIClipboardItem* self);
static GIcon* diodon_file_clipboard_item_real_get_icon (DiodonIClipboardItem* base);
gchar* diodon_iclipboard_item_get_mime_type (DiodonIClipboardItem* self);
static GByteArray* diodon_file_clipboard_item_real_get_payload (DiodonIClipboardItem* base, GError** error);
static gchar* diodon_file_clipboard_item_real_get_checksum (DiodonIClipboardItem* base);
static void diodon_file_clipboard_item_real_to_clipboard (DiodonIClipboardItem* base, GtkClipboard* clipboard);
static void diodon_file_clipboard_item_get_clipboard_data_callback (GtkClipboard* clipboard, GtkSelectionData* selection_data, guint info, void* user_data);
static void diodon_file_clipboard_item_clear_clipboard_data_callback (GtkClipboard* clipboard, void* user_data);
static gboolean diodon_file_clipboard_item_real_equals (DiodonIClipboardItem* base, DiodonIClipboardItem* item);
gchar* diodon_iclipboard_item_get_text (DiodonIClipboardItem* self);
static guint diodon_file_clipboard_item_real_hash (DiodonIClipboardItem* base);
static gchar* diodon_file_clipboard_item_join (const gchar* separator, gchar** array, int array_length1);
static guchar* diodon_file_clipboard_item_string_to_uchar_array (const gchar* str, int* result_length1);
static void _vala_array_add1 (guchar** array, int* length, int* size, guchar value);
static void diodon_file_clipboard_item_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
         * Default data constructor needed for reflection.
         * 
         * @param clipboard_type clipboard type item is coming from
         * @param data paths separated with \n
         * @param origin origin of clipboard item as application path
         */
static gpointer _g_date_time_ref0 (gpointer self) {
#line 54 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 167 "file-clipboard-item.c"
}


DiodonFileClipboardItem* diodon_file_clipboard_item_construct (GType object_type, DiodonClipboardType clipboard_type, const gchar* data, const gchar* origin, GDateTime* date_copied, GError** error) {
	DiodonFileClipboardItem * self = NULL;
	DiodonClipboardType _tmp0_ = 0;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	GDateTime* _tmp5_ = NULL;
	GDateTime* _tmp6_ = NULL;
	gchar** paths = NULL;
	const gchar* _tmp7_ = NULL;
	gint _tmp8_ = 0;
	gchar** _tmp9_ = NULL;
	gint paths_length1 = 0;
	gint _paths_size_ = 0;
	gchar** _tmp10_ = NULL;
	gint _tmp10__length1 = 0;
	GError * _inner_error_ = NULL;
#line 49 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 49 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	g_return_val_if_fail (date_copied != NULL, NULL);
#line 49 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	self = (DiodonFileClipboardItem*) g_object_new (object_type, NULL);
#line 51 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp0_ = clipboard_type;
#line 51 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	self->priv->_clipboard_type = _tmp0_;
#line 52 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp1_ = data;
#line 52 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 52 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_g_free0 (self->priv->_paths);
#line 52 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	self->priv->_paths = _tmp2_;
#line 53 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp3_ = origin;
#line 53 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 53 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_g_free0 (self->priv->_origin);
#line 53 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	self->priv->_origin = _tmp4_;
#line 54 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp5_ = date_copied;
#line 54 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp6_ = _g_date_time_ref0 (_tmp5_);
#line 54 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_g_date_time_unref0 (self->priv->_date_copied);
#line 54 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	self->priv->_date_copied = _tmp6_;
#line 57 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp7_ = self->priv->_paths;
#line 57 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp9_ = diodon_file_clipboard_item_convert_to_paths (_tmp7_, &_tmp8_);
#line 57 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	paths = _tmp9_;
#line 57 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	paths_length1 = _tmp8_;
#line 57 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_paths_size_ = paths_length1;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp10_ = paths;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp10__length1 = paths_length1;
#line 237 "file-clipboard-item.c"
	{
		gchar** path_collection = NULL;
		gint path_collection_length1 = 0;
		gint _path_collection_size_ = 0;
		gint path_it = 0;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		path_collection = _tmp10_;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		path_collection_length1 = _tmp10__length1;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		for (path_it = 0; path_it < _tmp10__length1; path_it = path_it + 1) {
#line 249 "file-clipboard-item.c"
			const gchar* path = NULL;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			path = path_collection[path_it];
#line 253 "file-clipboard-item.c"
			{
				GFile* file = NULL;
				const gchar* _tmp11_ = NULL;
				GFile* _tmp12_ = NULL;
				GFile* _tmp13_ = NULL;
				gboolean _tmp14_ = FALSE;
#line 59 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp11_ = path;
#line 59 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp12_ = g_file_new_for_path (_tmp11_);
#line 59 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				file = _tmp12_;
#line 60 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp13_ = file;
#line 60 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp14_ = g_file_query_exists (_tmp13_, NULL);
#line 60 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				if (!_tmp14_) {
#line 272 "file-clipboard-item.c"
					const gchar* _tmp15_ = NULL;
					gchar* _tmp16_ = NULL;
					gchar* _tmp17_ = NULL;
					GError* _tmp18_ = NULL;
					GError* _tmp19_ = NULL;
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					_tmp15_ = path;
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					_tmp16_ = g_strconcat ("No such file or directory ", _tmp15_, NULL);
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					_tmp17_ = _tmp16_;
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					_tmp18_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_NOENT, _tmp17_);
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					_tmp19_ = _tmp18_;
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					_g_free0 (_tmp17_);
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					_inner_error_ = _tmp19_;
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					if (_inner_error_->domain == G_FILE_ERROR) {
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
						g_propagate_error (error, _inner_error_);
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
						_g_object_unref0 (file);
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
						paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
						_g_object_unref0 (self);
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
						return NULL;
#line 304 "file-clipboard-item.c"
					} else {
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
						_g_object_unref0 (file);
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
						paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
						g_clear_error (&_inner_error_);
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
						return NULL;
#line 316 "file-clipboard-item.c"
					}
				}
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_g_object_unref0 (file);
#line 321 "file-clipboard-item.c"
			}
		}
	}
#line 49 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
#line 49 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	return self;
#line 329 "file-clipboard-item.c"
}


DiodonFileClipboardItem* diodon_file_clipboard_item_new (DiodonClipboardType clipboard_type, const gchar* data, const gchar* origin, GDateTime* date_copied, GError** error) {
#line 49 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	return diodon_file_clipboard_item_construct (DIODON_TYPE_FILE_CLIPBOARD_ITEM, clipboard_type, data, origin, date_copied, error);
#line 336 "file-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static DiodonClipboardType diodon_file_clipboard_item_real_get_clipboard_type (DiodonIClipboardItem* base) {
	DiodonFileClipboardItem * self;
	DiodonClipboardType result = 0;
	DiodonClipboardType _tmp0_ = 0;
#line 69 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_FILE_CLIPBOARD_ITEM, DiodonFileClipboardItem);
#line 71 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp0_ = self->priv->_clipboard_type;
#line 71 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	result = _tmp0_;
#line 71 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	return result;
#line 355 "file-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static GDateTime* diodon_file_clipboard_item_real_get_date_copied (DiodonIClipboardItem* base) {
	DiodonFileClipboardItem * self;
	GDateTime* result = NULL;
	GDateTime* _tmp0_ = NULL;
	GDateTime* _tmp1_ = NULL;
#line 77 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_FILE_CLIPBOARD_ITEM, DiodonFileClipboardItem);
#line 79 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp0_ = self->priv->_date_copied;
#line 79 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp1_ = _g_date_time_ref0 (_tmp0_);
#line 79 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	result = _tmp1_;
#line 79 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	return result;
#line 377 "file-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static gchar* diodon_file_clipboard_item_real_get_text (DiodonIClipboardItem* base) {
	DiodonFileClipboardItem * self;
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 85 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_FILE_CLIPBOARD_ITEM, DiodonFileClipboardItem);
#line 87 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp0_ = self->priv->_paths;
#line 87 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 87 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	result = _tmp1_;
#line 87 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	return result;
#line 399 "file-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static gchar* diodon_file_clipboard_item_real_get_origin (DiodonIClipboardItem* base) {
	DiodonFileClipboardItem * self;
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 93 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_FILE_CLIPBOARD_ITEM, DiodonFileClipboardItem);
#line 95 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp0_ = self->priv->_origin;
#line 95 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 95 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	result = _tmp1_;
#line 95 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	return result;
#line 421 "file-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1380 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1380 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1380 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 437 "file-clipboard-item.c"
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
#line 1382 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp0_ = old;
#line 1382 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
#line 1382 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1382 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
#line 1382 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1382 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_g_free0 (_tmp2_);
#line 1382 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		regex = _tmp4_;
#line 1382 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1382 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 468 "file-clipboard-item.c"
				goto __catch4_g_regex_error;
			}
#line 1382 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1382 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1382 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
			return NULL;
#line 477 "file-clipboard-item.c"
		}
#line 1383 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp6_ = regex;
#line 1383 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp7_ = replacement;
#line 1383 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) -1, 0, _tmp7_, 0, &_inner_error_);
#line 1383 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp5_ = _tmp8_;
#line 1383 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1383 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1383 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 493 "file-clipboard-item.c"
				goto __catch4_g_regex_error;
			}
#line 1383 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1383 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1383 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1383 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
			return NULL;
#line 504 "file-clipboard-item.c"
		}
#line 1383 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp9_ = _tmp5_;
#line 1383 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp5_ = NULL;
#line 1383 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		result = _tmp9_;
#line 1383 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_g_free0 (_tmp5_);
#line 1383 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1383 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		return result;
#line 518 "file-clipboard-item.c"
	}
	goto __finally4;
	__catch4_g_regex_error:
	{
		GError* e = NULL;
#line 1381 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1381 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1385 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1381 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 532 "file-clipboard-item.c"
	}
	__finally4:
#line 1381 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1381 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1381 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1381 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		return NULL;
#line 543 "file-clipboard-item.c"
	}
}


static gint string_index_of_nth_char (const gchar* self, glong c) {
	gint result = 0;
	glong _tmp0_ = 0L;
	gchar* _tmp1_ = NULL;
#line 1136 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1137 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	_tmp0_ = c;
#line 1137 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	_tmp1_ = g_utf8_offset_to_pointer (self, _tmp0_);
#line 1137 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	result = (gint) (_tmp1_ - ((gchar*) self));
#line 1137 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	return result;
#line 562 "file-clipboard-item.c"
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_ = NULL;
	glong _tmp1_ = 0L;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 1295 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1295 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1295 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1295 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1296 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1296 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 585 "file-clipboard-item.c"
		glong _tmp4_ = 0L;
#line 1297 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1297 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1297 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		return result;
#line 593 "file-clipboard-item.c"
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
#line 1299 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1299 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1299 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1299 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		return result;
#line 605 "file-clipboard-item.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_ = 0L;
	glong _tmp8_ = 0L;
	glong _tmp14_ = 0L;
	glong _tmp17_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	glong _tmp21_ = 0L;
	gchar* _tmp22_ = NULL;
#line 1306 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1308 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1308 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 629 "file-clipboard-item.c"
		glong _tmp2_ = 0L;
#line 1308 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1308 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 635 "file-clipboard-item.c"
	} else {
#line 1308 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 639 "file-clipboard-item.c"
	}
#line 1308 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 643 "file-clipboard-item.c"
		glong _tmp3_ = 0L;
		glong _tmp4_ = 0L;
		glong _tmp5_ = 0L;
#line 1310 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp3_ = offset;
#line 1310 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp4_ = len;
#line 1310 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp5_ = string_strnlen ((gchar*) self, _tmp3_ + _tmp4_);
#line 1310 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		string_length = _tmp5_;
#line 655 "file-clipboard-item.c"
	} else {
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
#line 1312 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp6_ = strlen (self);
#line 1312 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp7_ = _tmp6_;
#line 1312 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp7_;
#line 665 "file-clipboard-item.c"
	}
#line 1315 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	_tmp8_ = offset;
#line 1315 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	if (_tmp8_ < ((glong) 0)) {
#line 671 "file-clipboard-item.c"
		glong _tmp9_ = 0L;
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
#line 1316 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp9_ = string_length;
#line 1316 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp10_ = offset;
#line 1316 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		offset = _tmp9_ + _tmp10_;
#line 1317 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1317 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp11_ >= ((glong) 0), NULL);
#line 685 "file-clipboard-item.c"
	} else {
		glong _tmp12_ = 0L;
		glong _tmp13_ = 0L;
#line 1319 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1319 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp13_ = string_length;
#line 1319 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ <= _tmp13_, NULL);
#line 695 "file-clipboard-item.c"
	}
#line 1321 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	_tmp14_ = len;
#line 1321 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	if (_tmp14_ < ((glong) 0)) {
#line 701 "file-clipboard-item.c"
		glong _tmp15_ = 0L;
		glong _tmp16_ = 0L;
#line 1322 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp15_ = string_length;
#line 1322 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		_tmp16_ = offset;
#line 1322 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
		len = _tmp15_ - _tmp16_;
#line 710 "file-clipboard-item.c"
	}
#line 1324 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	_tmp17_ = offset;
#line 1324 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	_tmp18_ = len;
#line 1324 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	_tmp19_ = string_length;
#line 1324 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp17_ + _tmp18_) <= _tmp19_, NULL);
#line 1325 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	_tmp20_ = offset;
#line 1325 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	_tmp21_ = len;
#line 1325 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	_tmp22_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) _tmp21_);
#line 1325 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	result = _tmp22_;
#line 1325 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	return result;
#line 730 "file-clipboard-item.c"
}


static gchar* diodon_file_clipboard_item_real_get_label (DiodonIClipboardItem* base) {
	DiodonFileClipboardItem * self;
	gchar* result = NULL;
	gchar* home = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* label = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	gint _tmp8_ = 0;
#line 101 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_FILE_CLIPBOARD_ITEM, DiodonFileClipboardItem);
#line 103 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp0_ = g_get_home_dir ();
#line 103 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 103 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	home = _tmp1_;
#line 106 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp2_ = self->priv->_paths;
#line 106 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp3_ = string_replace (_tmp2_, "\n", " ");
#line 106 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	label = _tmp3_;
#line 109 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp4_ = label;
#line 109 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp5_ = home;
#line 109 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp6_ = string_replace (_tmp4_, _tmp5_, "~");
#line 109 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_g_free0 (label);
#line 109 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	label = _tmp6_;
#line 111 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp7_ = label;
#line 111 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp8_ = g_utf8_strlen (_tmp7_, (gssize) -1);
#line 111 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	if (_tmp8_ > 50) {
#line 778 "file-clipboard-item.c"
		glong index_char = 0L;
		const gchar* _tmp9_ = NULL;
		gint _tmp10_ = 0;
		const gchar* _tmp11_ = NULL;
		glong _tmp12_ = 0L;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
#line 112 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp9_ = label;
#line 112 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp10_ = string_index_of_nth_char (_tmp9_, (glong) 50);
#line 112 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		index_char = (glong) _tmp10_;
#line 113 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp11_ = label;
#line 113 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp12_ = index_char;
#line 113 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp13_ = string_substring (_tmp11_, (glong) 0, _tmp12_);
#line 113 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp14_ = _tmp13_;
#line 113 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp15_ = g_strconcat (_tmp14_, "...", NULL);
#line 113 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_g_free0 (label);
#line 113 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		label = _tmp15_;
#line 113 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_g_free0 (_tmp14_);
#line 809 "file-clipboard-item.c"
	}
#line 116 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	result = label;
#line 116 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_g_free0 (home);
#line 116 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	return result;
#line 817 "file-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static gchar* diodon_file_clipboard_item_real_get_mime_type (DiodonIClipboardItem* base) {
	DiodonFileClipboardItem * self;
	gchar* result = NULL;
	gchar* mime_type = NULL;
	gchar* _tmp0_ = NULL;
	gchar** uris = NULL;
	const gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gchar** _tmp3_ = NULL;
	gint uris_length1 = 0;
	gint _uris_size_ = 0;
	GFile* file = NULL;
	const gchar* _tmp4_ = NULL;
	GFile* _tmp5_ = NULL;
	GError * _inner_error_ = NULL;
#line 122 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_FILE_CLIPBOARD_ITEM, DiodonFileClipboardItem);
#line 126 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp0_ = g_strdup ("text/plain");
#line 126 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	mime_type = _tmp0_;
#line 127 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp1_ = self->priv->_paths;
#line 127 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp3_ = diodon_file_clipboard_item_convert_to_uris (_tmp1_, &_tmp2_);
#line 127 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	uris = _tmp3_;
#line 127 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	uris_length1 = _tmp2_;
#line 127 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_uris_size_ = uris_length1;
#line 128 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp4_ = uris[0];
#line 128 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp5_ = g_file_new_for_uri (_tmp4_);
#line 128 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	file = _tmp5_;
#line 861 "file-clipboard-item.c"
	{
		GFileInfo* file_info = NULL;
		GFileInfo* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
#line 130 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp6_ = g_file_query_info (file, G_FILE_ATTRIBUTE_STANDARD_FAST_CONTENT_TYPE, 0, NULL, &_inner_error_);
#line 130 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		file_info = _tmp6_;
#line 130 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 872 "file-clipboard-item.c"
			goto __catch5_g_error;
		}
#line 131 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp7_ = g_file_info_get_attribute_as_string (file_info, G_FILE_ATTRIBUTE_STANDARD_FAST_CONTENT_TYPE);
#line 131 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_g_free0 (mime_type);
#line 131 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		mime_type = _tmp7_;
#line 129 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_g_object_unref0 (file_info);
#line 883 "file-clipboard-item.c"
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp8_ = NULL;
#line 129 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		e = _inner_error_;
#line 129 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_inner_error_ = NULL;
#line 133 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp8_ = uris[0];
#line 133 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		g_warning ("file-clipboard-item.vala:133: Could not determine mime type of file %s", _tmp8_);
#line 129 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_g_error_free0 (e);
#line 900 "file-clipboard-item.c"
	}
	__finally5:
#line 129 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 129 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_g_object_unref0 (file);
#line 129 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 129 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_g_free0 (mime_type);
#line 129 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 129 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		g_clear_error (&_inner_error_);
#line 129 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		return NULL;
#line 917 "file-clipboard-item.c"
	}
#line 136 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	result = mime_type;
#line 136 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_g_object_unref0 (file);
#line 136 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 136 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	return result;
#line 927 "file-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static DiodonClipboardCategory diodon_file_clipboard_item_real_get_category (DiodonIClipboardItem* base) {
	DiodonFileClipboardItem * self;
	DiodonClipboardCategory result = 0;
#line 142 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_FILE_CLIPBOARD_ITEM, DiodonFileClipboardItem);
#line 144 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	result = DIODON_CLIPBOARD_CATEGORY_FILES;
#line 144 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	return result;
#line 943 "file-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static GtkImage* diodon_file_clipboard_item_real_get_image (DiodonIClipboardItem* base) {
	DiodonFileClipboardItem * self;
	GtkImage* result = NULL;
	GtkImage* image = NULL;
	GIcon* _tmp0_ = NULL;
	GIcon* _tmp1_ = NULL;
	GtkImage* _tmp2_ = NULL;
	GtkImage* _tmp3_ = NULL;
#line 150 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_FILE_CLIPBOARD_ITEM, DiodonFileClipboardItem);
#line 152 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp0_ = diodon_iclipboard_item_get_icon (G_TYPE_CHECK_INSTANCE_CAST (self, DIODON_TYPE_ICLIPBOARD_ITEM, DiodonIClipboardItem));
#line 152 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp1_ = _tmp0_;
#line 152 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp2_ = (GtkImage*) gtk_image_new_from_gicon (_tmp1_, GTK_ICON_SIZE_MENU);
#line 152 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	g_object_ref_sink (_tmp2_);
#line 152 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp3_ = _tmp2_;
#line 152 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_g_object_unref0 (_tmp1_);
#line 152 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	image = _tmp3_;
#line 153 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	result = image;
#line 153 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	return result;
#line 978 "file-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static gpointer _g_object_ref0 (gpointer self) {
#line 170 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	return self ? g_object_ref (self) : NULL;
#line 988 "file-clipboard-item.c"
}


static GIcon* diodon_file_clipboard_item_real_get_icon (DiodonIClipboardItem* base) {
	DiodonFileClipboardItem * self;
	GIcon* result = NULL;
#line 161 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	static const char FILE_ATTRS[] = G_FILE_ATTRIBUTE_THUMBNAIL_PATH;
#line 997 "file-clipboard-item.c"
	gchar* mime_type = NULL;
	gchar* _tmp0_ = NULL;
	gchar** uris = NULL;
	const gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gchar** _tmp3_ = NULL;
	gint uris_length1 = 0;
	gint _uris_size_ = 0;
	GFile* file = NULL;
	gchar** _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	const gchar* _tmp5_ = NULL;
	GFile* _tmp6_ = NULL;
	const gchar* _tmp24_ = NULL;
	GIcon* _tmp25_ = NULL;
	GError * _inner_error_ = NULL;
#line 159 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_FILE_CLIPBOARD_ITEM, DiodonFileClipboardItem);
#line 165 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp0_ = diodon_iclipboard_item_get_mime_type (G_TYPE_CHECK_INSTANCE_CAST (self, DIODON_TYPE_ICLIPBOARD_ITEM, DiodonIClipboardItem));
#line 165 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	mime_type = _tmp0_;
#line 166 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp1_ = self->priv->_paths;
#line 166 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp3_ = diodon_file_clipboard_item_convert_to_uris (_tmp1_, &_tmp2_);
#line 166 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	uris = _tmp3_;
#line 166 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	uris_length1 = _tmp2_;
#line 166 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_uris_size_ = uris_length1;
#line 167 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp4_ = uris;
#line 167 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp4__length1 = uris_length1;
#line 167 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp5_ = _tmp4_[0];
#line 167 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp6_ = g_file_new_for_uri (_tmp5_);
#line 167 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	file = _tmp6_;
#line 1040 "file-clipboard-item.c"
	{
		GFileInfo* info = NULL;
		GFile* _tmp7_ = NULL;
		GFileInfo* _tmp8_ = NULL;
		GIcon* icon = NULL;
		GFileInfo* _tmp9_ = NULL;
		GIcon* _tmp10_ = NULL;
		GIcon* _tmp11_ = NULL;
		gchar* thumbnail_path = NULL;
		GFileInfo* _tmp12_ = NULL;
		const gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		const gchar* _tmp15_ = NULL;
#line 169 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp7_ = file;
#line 169 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp8_ = g_file_query_info (_tmp7_, FILE_ATTRS, 0, NULL, &_inner_error_);
#line 169 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		info = _tmp8_;
#line 169 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1062 "file-clipboard-item.c"
			goto __catch6_g_error;
		}
#line 170 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp9_ = info;
#line 170 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp10_ = g_file_info_get_icon (_tmp9_);
#line 170 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp11_ = _g_object_ref0 (_tmp10_);
#line 170 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		icon = _tmp11_;
#line 171 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp12_ = info;
#line 171 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp13_ = g_file_info_get_attribute_byte_string (_tmp12_, G_FILE_ATTRIBUTE_THUMBNAIL_PATH);
#line 171 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp14_ = g_strdup (_tmp13_);
#line 171 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		thumbnail_path = _tmp14_;
#line 172 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp15_ = thumbnail_path;
#line 172 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		if (_tmp15_ != NULL) {
#line 1085 "file-clipboard-item.c"
			const gchar* _tmp16_ = NULL;
			GFile* _tmp17_ = NULL;
			GFile* _tmp18_ = NULL;
			GFileIcon* _tmp19_ = NULL;
			GIcon* _tmp20_ = NULL;
#line 173 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp16_ = thumbnail_path;
#line 173 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp17_ = g_file_new_for_path (_tmp16_);
#line 173 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp18_ = _tmp17_;
#line 173 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp19_ = (GFileIcon*) g_file_icon_new (_tmp18_);
#line 173 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp20_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, G_TYPE_ICON, GIcon);
#line 173 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_g_object_unref0 (_tmp18_);
#line 173 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			result = _tmp20_;
#line 173 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_g_free0 (thumbnail_path);
#line 173 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_g_object_unref0 (icon);
#line 173 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_g_object_unref0 (info);
#line 173 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_g_object_unref0 (file);
#line 173 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 173 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_g_free0 (mime_type);
#line 173 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			return result;
#line 1119 "file-clipboard-item.c"
		} else {
			GIcon* _tmp21_ = NULL;
#line 175 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp21_ = icon;
#line 175 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			if (_tmp21_ != NULL) {
#line 176 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				result = icon;
#line 176 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_g_free0 (thumbnail_path);
#line 176 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_g_object_unref0 (info);
#line 176 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_g_object_unref0 (file);
#line 176 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 176 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_g_free0 (mime_type);
#line 176 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				return result;
#line 1140 "file-clipboard-item.c"
			}
		}
#line 168 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_g_free0 (thumbnail_path);
#line 168 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_g_object_unref0 (icon);
#line 168 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_g_object_unref0 (info);
#line 1149 "file-clipboard-item.c"
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError* e = NULL;
		gchar** _tmp22_ = NULL;
		gint _tmp22__length1 = 0;
		const gchar* _tmp23_ = NULL;
#line 168 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		e = _inner_error_;
#line 168 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_inner_error_ = NULL;
#line 179 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp22_ = uris;
#line 179 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp22__length1 = uris_length1;
#line 179 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp23_ = _tmp22_[0];
#line 179 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		g_warning ("file-clipboard-item.vala:179: Could not determine mime type of file %s", _tmp23_);
#line 168 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_g_error_free0 (e);
#line 1172 "file-clipboard-item.c"
	}
	__finally6:
#line 168 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 168 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_g_object_unref0 (file);
#line 168 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 168 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_g_free0 (mime_type);
#line 168 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 168 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		g_clear_error (&_inner_error_);
#line 168 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		return NULL;
#line 1189 "file-clipboard-item.c"
	}
#line 183 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp24_ = mime_type;
#line 183 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp25_ = g_content_type_get_icon (_tmp24_);
#line 183 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	result = _tmp25_;
#line 183 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_g_object_unref0 (file);
#line 183 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 183 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_g_free0 (mime_type);
#line 183 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	return result;
#line 1205 "file-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static GByteArray* diodon_file_clipboard_item_real_get_payload (DiodonIClipboardItem* base, GError** error) {
	DiodonFileClipboardItem * self;
	GByteArray* result = NULL;
#line 189 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_FILE_CLIPBOARD_ITEM, DiodonFileClipboardItem);
#line 191 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	result = NULL;
#line 191 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	return result;
#line 1221 "file-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static gchar* diodon_file_clipboard_item_real_get_checksum (DiodonIClipboardItem* base) {
	DiodonFileClipboardItem * self;
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 197 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_FILE_CLIPBOARD_ITEM, DiodonFileClipboardItem);
#line 199 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp0_ = self->priv->_paths;
#line 199 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp1_ = g_compute_checksum_for_string (G_CHECKSUM_SHA1, _tmp0_, (gsize) -1);
#line 199 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	result = _tmp1_;
#line 199 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	return result;
#line 1243 "file-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static void diodon_file_clipboard_item_real_to_clipboard (DiodonIClipboardItem* base, GtkClipboard* clipboard) {
	DiodonFileClipboardItem * self;
	GtkTargetEntry* targets = NULL;
	gint targets_length1 = 0;
	gint _targets_size_ = 0;
	GtkTargetList* target_list = NULL;
	GtkTargetEntry* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	GtkTargetList* _tmp1_ = NULL;
	GdkAtom _tmp2_ = 0U;
	gint _tmp3_ = 0;
	GtkTargetEntry* _tmp4_ = NULL;
	GtkClipboard* _tmp5_ = NULL;
	GtkTargetEntry* _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
	GtkClipboard* _tmp7_ = NULL;
#line 205 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_FILE_CLIPBOARD_ITEM, DiodonFileClipboardItem);
#line 205 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	g_return_if_fail (GTK_IS_CLIPBOARD (clipboard));
#line 208 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	targets = NULL;
#line 208 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	targets_length1 = 0;
#line 208 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_targets_size_ = targets_length1;
#line 209 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp0_ = targets;
#line 209 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp0__length1 = targets_length1;
#line 209 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp1_ = gtk_target_list_new (_tmp0_, _tmp0__length1);
#line 209 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	target_list = _tmp1_;
#line 210 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	gtk_target_list_add_text_targets (target_list, (guint) 0);
#line 211 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	gtk_target_list_add_uri_targets (target_list, (guint) 0);
#line 212 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp2_ = diodon_file_clipboard_item_copy_files;
#line 212 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	gtk_target_list_add (target_list, _tmp2_, (guint) 0, (guint) 0);
#line 213 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp4_ = gtk_target_table_new_from_list (target_list, &_tmp3_);
#line 213 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	targets = (g_free (targets), NULL);
#line 213 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	targets = _tmp4_;
#line 213 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	targets_length1 = _tmp3_;
#line 213 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_targets_size_ = targets_length1;
#line 217 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp5_ = clipboard;
#line 217 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp6_ = targets;
#line 217 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp6__length1 = targets_length1;
#line 217 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	gtk_clipboard_set_with_owner (_tmp5_, _tmp6_, _tmp6__length1, (GtkClipboardGetFunc) diodon_file_clipboard_item_get_clipboard_data_callback, (GtkClipboardClearFunc) diodon_file_clipboard_item_clear_clipboard_data_callback, G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject));
#line 223 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp7_ = clipboard;
#line 223 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	gtk_clipboard_store (_tmp7_);
#line 205 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_gtk_target_list_unref0 (target_list);
#line 205 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	targets = (g_free (targets), NULL);
#line 1318 "file-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static gboolean diodon_file_clipboard_item_real_equals (DiodonIClipboardItem* base, DiodonIClipboardItem* item) {
	DiodonFileClipboardItem * self;
	gboolean result = FALSE;
	gboolean equals = FALSE;
	DiodonIClipboardItem* _tmp0_ = NULL;
#line 229 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_FILE_CLIPBOARD_ITEM, DiodonFileClipboardItem);
#line 231 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	equals = FALSE;
#line 233 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp0_ = item;
#line 233 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, DIODON_TYPE_FILE_CLIPBOARD_ITEM)) {
#line 1338 "file-clipboard-item.c"
		GCompareFunc _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		DiodonIClipboardItem* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gint _tmp6_ = 0;
#line 234 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp1_ = g_strcmp0;
#line 234 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp2_ = self->priv->_paths;
#line 234 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp3_ = item;
#line 234 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp4_ = diodon_iclipboard_item_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, DIODON_TYPE_ICLIPBOARD_ITEM, DiodonIClipboardItem));
#line 234 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp5_ = _tmp4_;
#line 234 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp6_ = _tmp1_ (_tmp2_, _tmp5_);
#line 234 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		equals = _tmp6_ == 0;
#line 234 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_g_free0 (_tmp5_);
#line 1361 "file-clipboard-item.c"
	}
#line 237 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	result = equals;
#line 237 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	return result;
#line 1367 "file-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static guint diodon_file_clipboard_item_real_hash (DiodonIClipboardItem* base) {
	DiodonFileClipboardItem * self;
	guint result = 0U;
	GHashFunc _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	guint _tmp2_ = 0U;
#line 243 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_FILE_CLIPBOARD_ITEM, DiodonFileClipboardItem);
#line 245 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp0_ = g_str_hash;
#line 245 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp1_ = self->priv->_paths;
#line 245 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp2_ = _tmp0_ (_tmp1_);
#line 245 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	result = _tmp2_;
#line 245 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	return result;
#line 1392 "file-clipboard-item.c"
}


/**
         * Callback method called by Gtk.Clipboard to get the clipboard data
         * whereas in this case it is the path as text and the uri for
         * pasting file itself. Static as instance to FileClipboardItem is passed on
         * as user_data.
         */
static void diodon_file_clipboard_item_get_clipboard_data_callback (GtkClipboard* clipboard, GtkSelectionData* selection_data, guint info, void* user_data) {
	DiodonFileClipboardItem* item = NULL;
	void* _tmp0_ = NULL;
	DiodonFileClipboardItem* _tmp1_ = NULL;
	GdkAtom* targets = NULL;
	GdkAtom* _tmp2_ = NULL;
	gint targets_length1 = 0;
	gint _targets_size_ = 0;
	GdkAtom* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	GtkSelectionData* _tmp4_ = NULL;
	GdkAtom _tmp5_ = 0U;
	GdkAtom _tmp6_ = 0U;
	GdkAtom* _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	gboolean _tmp8_ = FALSE;
#line 254 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	g_return_if_fail (GTK_IS_CLIPBOARD (clipboard));
#line 254 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	g_return_if_fail (selection_data != NULL);
#line 257 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp0_ = user_data;
#line 257 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, DIODON_TYPE_FILE_CLIPBOARD_ITEM, DiodonFileClipboardItem));
#line 257 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	item = _tmp1_;
#line 259 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp2_ = g_new0 (GdkAtom, 1);
#line 259 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	targets = _tmp2_;
#line 259 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	targets_length1 = 1;
#line 259 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_targets_size_ = targets_length1;
#line 260 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp3_ = targets;
#line 260 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp3__length1 = targets_length1;
#line 260 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp4_ = selection_data;
#line 260 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp5_ = gtk_selection_data_get_target (_tmp4_);
#line 260 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp3_[0] = _tmp5_;
#line 260 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp6_ = _tmp3_[0];
#line 263 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp7_ = targets;
#line 263 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp7__length1 = targets_length1;
#line 263 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp8_ = gtk_targets_include_text (_tmp7_, _tmp7__length1);
#line 263 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	if (_tmp8_) {
#line 1456 "file-clipboard-item.c"
		GtkSelectionData* _tmp9_ = NULL;
		DiodonFileClipboardItem* _tmp10_ = NULL;
		const gchar* _tmp11_ = NULL;
#line 264 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		g_debug ("file-clipboard-item.vala:264: get clipboard file data as text");
#line 265 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp9_ = selection_data;
#line 265 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp10_ = item;
#line 265 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp11_ = _tmp10_->priv->_paths;
#line 265 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		gtk_selection_data_set_text (_tmp9_, _tmp11_, -1);
#line 1470 "file-clipboard-item.c"
	} else {
		GdkAtom* _tmp12_ = NULL;
		gint _tmp12__length1 = 0;
		gboolean _tmp13_ = FALSE;
#line 267 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp12_ = targets;
#line 267 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp12__length1 = targets_length1;
#line 267 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp13_ = gtk_targets_include_uri (_tmp12_, _tmp12__length1);
#line 267 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		if (_tmp13_) {
#line 1483 "file-clipboard-item.c"
			gchar** uris = NULL;
			DiodonFileClipboardItem* _tmp14_ = NULL;
			const gchar* _tmp15_ = NULL;
			gint _tmp16_ = 0;
			gchar** _tmp17_ = NULL;
			gint uris_length1 = 0;
			gint _uris_size_ = 0;
			GtkSelectionData* _tmp18_ = NULL;
			gchar** _tmp19_ = NULL;
			gint _tmp19__length1 = 0;
#line 268 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			g_debug ("file-clipboard-item.vala:268: get clipboard file data as uris");
#line 269 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp14_ = item;
#line 269 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp15_ = _tmp14_->priv->_paths;
#line 269 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp17_ = diodon_file_clipboard_item_convert_to_uris (_tmp15_, &_tmp16_);
#line 269 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			uris = _tmp17_;
#line 269 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			uris_length1 = _tmp16_;
#line 269 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_uris_size_ = uris_length1;
#line 270 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp18_ = selection_data;
#line 270 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp19_ = uris;
#line 270 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp19__length1 = uris_length1;
#line 270 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			gtk_selection_data_set_uris (_tmp18_, _tmp19_);
#line 267 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 1518 "file-clipboard-item.c"
		} else {
			gchar** uris = NULL;
			DiodonFileClipboardItem* _tmp20_ = NULL;
			const gchar* _tmp21_ = NULL;
			gint _tmp22_ = 0;
			gchar** _tmp23_ = NULL;
			gint uris_length1 = 0;
			gint _uris_size_ = 0;
			gchar* copy_files_data = NULL;
			gchar** _tmp24_ = NULL;
			gint _tmp24__length1 = 0;
			gchar* _tmp25_ = NULL;
			gchar* _tmp26_ = NULL;
			gchar* _tmp27_ = NULL;
			gchar* _tmp28_ = NULL;
			GtkSelectionData* _tmp29_ = NULL;
			GdkAtom _tmp30_ = 0U;
			const gchar* _tmp31_ = NULL;
			gint _tmp32_ = 0;
			guchar* _tmp33_ = NULL;
			guchar* _tmp34_ = NULL;
			gint _tmp34__length1 = 0;
#line 273 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			g_debug ("file-clipboard-item.vala:273: get clipboard file data as copied files");
#line 274 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp20_ = item;
#line 274 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp21_ = _tmp20_->priv->_paths;
#line 274 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp23_ = diodon_file_clipboard_item_convert_to_uris (_tmp21_, &_tmp22_);
#line 274 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			uris = _tmp23_;
#line 274 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			uris_length1 = _tmp22_;
#line 274 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_uris_size_ = uris_length1;
#line 277 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp24_ = uris;
#line 277 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp24__length1 = uris_length1;
#line 277 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp25_ = diodon_file_clipboard_item_join ("\n", _tmp24_, _tmp24__length1);
#line 277 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp26_ = _tmp25_;
#line 277 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp27_ = g_strconcat ("copy\n", _tmp26_, NULL);
#line 277 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp28_ = _tmp27_;
#line 277 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_g_free0 (_tmp26_);
#line 277 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			copy_files_data = _tmp28_;
#line 278 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp29_ = selection_data;
#line 278 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp30_ = diodon_file_clipboard_item_copy_files;
#line 278 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp31_ = copy_files_data;
#line 278 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp33_ = diodon_file_clipboard_item_string_to_uchar_array (_tmp31_, &_tmp32_);
#line 278 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp34_ = _tmp33_;
#line 278 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp34__length1 = _tmp32_;
#line 278 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			gtk_selection_data_set (_tmp29_, _tmp30_, 8, _tmp34_, _tmp32_);
#line 278 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp34_ = (g_free (_tmp34_), NULL);
#line 267 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_g_free0 (copy_files_data);
#line 267 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 1591 "file-clipboard-item.c"
		}
	}
#line 254 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	targets = (g_free (targets), NULL);
#line 254 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_g_object_unref0 (item);
#line 1598 "file-clipboard-item.c"
}


/**
         * Callback method called by Gtk.Clipboard to clear data.
         * Currently empty method as there is nothing to be cleared.
         */
static void diodon_file_clipboard_item_clear_clipboard_data_callback (GtkClipboard* clipboard, void* user_data) {
#line 286 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	g_return_if_fail (GTK_IS_CLIPBOARD (clipboard));
#line 1609 "file-clipboard-item.c"
}


/**
         * Helper method to convert string to uchar array.
         *
         * @param str string to be converted
         */
static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	glong _tmp0_ = 0L;
	gchar _tmp1_ = '\0';
#line 1086 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1087 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	_tmp0_ = index;
#line 1087 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	_tmp1_ = ((gchar*) self)[_tmp0_];
#line 1087 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 1087 "/usr/share/vala-0.32/vapi/glib-2.0.vapi"
	return result;
#line 1632 "file-clipboard-item.c"
}


static void _vala_array_add1 (guchar** array, int* length, int* size, guchar value) {
#line 299 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	if ((*length) == (*size)) {
#line 299 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 299 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		*array = g_renew (guchar, *array, *size);
#line 1643 "file-clipboard-item.c"
	}
#line 299 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	(*array)[(*length)++] = value;
#line 1647 "file-clipboard-item.c"
}


static guchar* diodon_file_clipboard_item_string_to_uchar_array (const gchar* str, int* result_length1) {
	guchar* result = NULL;
	guchar* data = NULL;
	guchar* _tmp0_ = NULL;
	gint data_length1 = 0;
	gint _data_size_ = 0;
	guchar* _tmp11_ = NULL;
	gint _tmp11__length1 = 0;
#line 295 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 297 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp0_ = g_new0 (guchar, 0);
#line 297 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	data = _tmp0_;
#line 297 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	data_length1 = 0;
#line 297 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_data_size_ = data_length1;
#line 1669 "file-clipboard-item.c"
	{
		gint i = 0;
#line 298 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		i = 0;
#line 1674 "file-clipboard-item.c"
		{
			gboolean _tmp1_ = FALSE;
#line 298 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp1_ = TRUE;
#line 298 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			while (TRUE) {
#line 1681 "file-clipboard-item.c"
				gint _tmp3_ = 0;
				const gchar* _tmp4_ = NULL;
				gint _tmp5_ = 0;
				gint _tmp6_ = 0;
				guchar* _tmp7_ = NULL;
				gint _tmp7__length1 = 0;
				const gchar* _tmp8_ = NULL;
				gint _tmp9_ = 0;
				gchar _tmp10_ = '\0';
#line 298 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				if (!_tmp1_) {
#line 1693 "file-clipboard-item.c"
					gint _tmp2_ = 0;
#line 298 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					_tmp2_ = i;
#line 298 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					i = _tmp2_ + 1;
#line 1699 "file-clipboard-item.c"
				}
#line 298 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp1_ = FALSE;
#line 298 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp3_ = i;
#line 298 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp4_ = str;
#line 298 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp5_ = strlen (_tmp4_);
#line 298 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp6_ = _tmp5_;
#line 298 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				if (!(_tmp3_ < _tmp6_)) {
#line 298 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					break;
#line 1715 "file-clipboard-item.c"
				}
#line 299 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp7_ = data;
#line 299 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp7__length1 = data_length1;
#line 299 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp8_ = str;
#line 299 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp9_ = i;
#line 299 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp10_ = string_get (_tmp8_, (glong) _tmp9_);
#line 299 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_vala_array_add1 (&data, &data_length1, &_data_size_, (guchar) _tmp10_);
#line 1729 "file-clipboard-item.c"
			}
		}
	}
#line 301 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp11_ = data;
#line 301 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp11__length1 = data_length1;
#line 301 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	if (result_length1) {
#line 301 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		*result_length1 = _tmp11__length1;
#line 1741 "file-clipboard-item.c"
	}
#line 301 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	result = _tmp11_;
#line 301 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	return result;
#line 1747 "file-clipboard-item.c"
}


/**
         * Helper method to join a array of string together with
         * given separator.
         *
         * @param separator separator to join string
         * @param array array of strings to be joined
         */
static gchar* diodon_file_clipboard_item_join (const gchar* separator, gchar** array, int array_length1) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
#line 311 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	g_return_val_if_fail (separator != NULL, NULL);
#line 313 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp0_ = g_strdup ("");
#line 313 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_result_ = _tmp0_;
#line 314 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp1_ = array;
#line 314 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp1__length1 = array_length1;
#line 314 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	if (_tmp1__length1 > 0) {
#line 1776 "file-clipboard-item.c"
		gchar** _tmp2_ = NULL;
		gint _tmp2__length1 = 0;
		const gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
#line 315 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp2_ = array;
#line 315 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp2__length1 = array_length1;
#line 315 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp3_ = _tmp2_[0];
#line 315 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_tmp4_ = g_strdup (_tmp3_);
#line 315 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_g_free0 (_result_);
#line 315 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		_result_ = _tmp4_;
#line 1793 "file-clipboard-item.c"
		{
			gint i = 0;
#line 316 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			i = 1;
#line 1798 "file-clipboard-item.c"
			{
				gboolean _tmp5_ = FALSE;
#line 316 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp5_ = TRUE;
#line 316 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				while (TRUE) {
#line 1805 "file-clipboard-item.c"
					gint _tmp7_ = 0;
					gchar** _tmp8_ = NULL;
					gint _tmp8__length1 = 0;
					const gchar* _tmp9_ = NULL;
					const gchar* _tmp10_ = NULL;
					gchar* _tmp11_ = NULL;
					const gchar* _tmp12_ = NULL;
					gchar** _tmp13_ = NULL;
					gint _tmp13__length1 = 0;
					gint _tmp14_ = 0;
					const gchar* _tmp15_ = NULL;
					gchar* _tmp16_ = NULL;
#line 316 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					if (!_tmp5_) {
#line 1820 "file-clipboard-item.c"
						gint _tmp6_ = 0;
#line 316 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
						_tmp6_ = i;
#line 316 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
						i = _tmp6_ + 1;
#line 1826 "file-clipboard-item.c"
					}
#line 316 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					_tmp5_ = FALSE;
#line 316 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					_tmp7_ = i;
#line 316 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					_tmp8_ = array;
#line 316 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					_tmp8__length1 = array_length1;
#line 316 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					if (!(_tmp7_ < _tmp8__length1)) {
#line 316 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
						break;
#line 1840 "file-clipboard-item.c"
					}
#line 317 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					_tmp9_ = _result_;
#line 317 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					_tmp10_ = separator;
#line 317 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					_tmp11_ = g_strconcat (_tmp9_, _tmp10_, NULL);
#line 317 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					_g_free0 (_result_);
#line 317 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					_result_ = _tmp11_;
#line 318 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					_tmp12_ = _result_;
#line 318 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					_tmp13_ = array;
#line 318 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					_tmp13__length1 = array_length1;
#line 318 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					_tmp14_ = i;
#line 318 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					_tmp15_ = _tmp13_[_tmp14_];
#line 318 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					_tmp16_ = g_strconcat (_tmp12_, _tmp15_, NULL);
#line 318 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					_g_free0 (_result_);
#line 318 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					_result_ = _tmp16_;
#line 1868 "file-clipboard-item.c"
				}
			}
		}
	}
#line 322 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	result = _result_;
#line 322 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	return result;
#line 1877 "file-clipboard-item.c"
}


/**
         * Convert given paths to uris
         *
         * @param paths paths to be converted
         */
static gchar** diodon_file_clipboard_item_convert_to_uris (const gchar* paths, int* result_length1) {
	gchar** result = NULL;
	gchar** uris = NULL;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gchar** _tmp2_ = NULL;
	gint uris_length1 = 0;
	gint _uris_size_ = 0;
	gchar** _tmp18_ = NULL;
	gint _tmp18__length1 = 0;
#line 330 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	g_return_val_if_fail (paths != NULL, NULL);
#line 332 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp0_ = paths;
#line 332 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp2_ = diodon_file_clipboard_item_convert_to_paths (_tmp0_, &_tmp1_);
#line 332 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	uris = _tmp2_;
#line 332 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	uris_length1 = _tmp1_;
#line 332 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_uris_size_ = uris_length1;
#line 1908 "file-clipboard-item.c"
	{
		gint i = 0;
#line 333 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		i = 0;
#line 1913 "file-clipboard-item.c"
		{
			gboolean _tmp3_ = FALSE;
#line 333 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			_tmp3_ = TRUE;
#line 333 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
			while (TRUE) {
#line 1920 "file-clipboard-item.c"
				gint _tmp5_ = 0;
				gchar** _tmp6_ = NULL;
				gint _tmp6__length1 = 0;
				gchar* uri = NULL;
				gchar** _tmp7_ = NULL;
				gint _tmp7__length1 = 0;
				gint _tmp8_ = 0;
				const gchar* _tmp9_ = NULL;
				gchar* _tmp10_ = NULL;
				const gchar* _tmp11_ = NULL;
				gchar* _tmp12_ = NULL;
				gchar** _tmp13_ = NULL;
				gint _tmp13__length1 = 0;
				gint _tmp14_ = 0;
				const gchar* _tmp15_ = NULL;
				gchar* _tmp16_ = NULL;
				gchar* _tmp17_ = NULL;
#line 333 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				if (!_tmp3_) {
#line 1940 "file-clipboard-item.c"
					gint _tmp4_ = 0;
#line 333 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					_tmp4_ = i;
#line 333 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					i = _tmp4_ + 1;
#line 1946 "file-clipboard-item.c"
				}
#line 333 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp3_ = FALSE;
#line 333 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp5_ = i;
#line 333 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp6_ = uris;
#line 333 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp6__length1 = uris_length1;
#line 333 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				if (!(_tmp5_ < _tmp6__length1)) {
#line 333 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
					break;
#line 1960 "file-clipboard-item.c"
				}
#line 334 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp7_ = uris;
#line 334 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp7__length1 = uris_length1;
#line 334 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp8_ = i;
#line 334 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp9_ = _tmp7_[_tmp8_];
#line 334 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp10_ = g_strdup (_tmp9_);
#line 334 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				uri = _tmp10_;
#line 335 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp11_ = uri;
#line 335 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp12_ = g_strconcat ("file://", _tmp11_, NULL);
#line 335 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_g_free0 (uri);
#line 335 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				uri = _tmp12_;
#line 336 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp13_ = uris;
#line 336 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp13__length1 = uris_length1;
#line 336 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp14_ = i;
#line 336 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp15_ = uri;
#line 336 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp16_ = g_strdup (_tmp15_);
#line 336 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_g_free0 (_tmp13_[_tmp14_]);
#line 336 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp13_[_tmp14_] = _tmp16_;
#line 336 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_tmp17_ = _tmp13_[_tmp14_];
#line 333 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
				_g_free0 (uri);
#line 2000 "file-clipboard-item.c"
			}
		}
	}
#line 339 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp18_ = uris;
#line 339 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp18__length1 = uris_length1;
#line 339 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	if (result_length1) {
#line 339 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		*result_length1 = _tmp18__length1;
#line 2012 "file-clipboard-item.c"
	}
#line 339 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	result = _tmp18_;
#line 339 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	return result;
#line 2018 "file-clipboard-item.c"
}


/**
         * Helper method to convert paths string to a path array
         *
         * @param path string with new line separator per path
         */
static gchar** diodon_file_clipboard_item_convert_to_paths (const gchar* paths, int* result_length1) {
	gchar** result = NULL;
	gchar** _result_ = NULL;
	const gchar* _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gint _result__length1 = 0;
	gint __result__size_ = 0;
	gchar** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
#line 347 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	g_return_val_if_fail (paths != NULL, NULL);
#line 349 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp0_ = paths;
#line 349 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp2_ = _tmp1_ = g_strsplit (_tmp0_, "\n", 0);
#line 349 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_result_ = _tmp2_;
#line 349 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_result__length1 = _vala_array_length (_tmp1_);
#line 349 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	__result__size_ = _result__length1;
#line 350 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp3_ = _result_;
#line 350 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp3__length1 = _result__length1;
#line 350 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	if (result_length1) {
#line 350 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
		*result_length1 = _tmp3__length1;
#line 2057 "file-clipboard-item.c"
	}
#line 350 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	result = _tmp3_;
#line 350 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	return result;
#line 2063 "file-clipboard-item.c"
}


static void diodon_file_clipboard_item_class_init (DiodonFileClipboardItemClass * klass) {
	GdkAtom _tmp0_ = 0U;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	diodon_file_clipboard_item_parent_class = g_type_class_peek_parent (klass);
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	g_type_class_add_private (klass, sizeof (DiodonFileClipboardItemPrivate));
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	G_OBJECT_CLASS (klass)->finalize = diodon_file_clipboard_item_finalize;
#line 32 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_tmp0_ = gdk_atom_intern_static_string ("x-special/gnome-copied-files");
#line 32 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	diodon_file_clipboard_item_copy_files = _tmp0_;
#line 2079 "file-clipboard-item.c"
}


static void diodon_file_clipboard_item_diodon_iclipboard_item_interface_init (DiodonIClipboardItemIface * iface) {
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	diodon_file_clipboard_item_diodon_iclipboard_item_parent_iface = g_type_interface_peek_parent (iface);
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	iface->get_clipboard_type = (DiodonClipboardType (*)(DiodonIClipboardItem*)) diodon_file_clipboard_item_real_get_clipboard_type;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	iface->get_date_copied = (GDateTime* (*)(DiodonIClipboardItem*)) diodon_file_clipboard_item_real_get_date_copied;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	iface->get_text = (gchar* (*)(DiodonIClipboardItem*)) diodon_file_clipboard_item_real_get_text;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	iface->get_origin = (gchar* (*)(DiodonIClipboardItem*)) diodon_file_clipboard_item_real_get_origin;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	iface->get_label = (gchar* (*)(DiodonIClipboardItem*)) diodon_file_clipboard_item_real_get_label;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	iface->get_mime_type = (gchar* (*)(DiodonIClipboardItem*)) diodon_file_clipboard_item_real_get_mime_type;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	iface->get_category = (DiodonClipboardCategory (*)(DiodonIClipboardItem*)) diodon_file_clipboard_item_real_get_category;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	iface->get_image = (GtkImage* (*)(DiodonIClipboardItem*)) diodon_file_clipboard_item_real_get_image;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	iface->get_icon = (GIcon* (*)(DiodonIClipboardItem*)) diodon_file_clipboard_item_real_get_icon;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	iface->get_payload = (GByteArray* (*)(DiodonIClipboardItem*, GError**)) diodon_file_clipboard_item_real_get_payload;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	iface->get_checksum = (gchar* (*)(DiodonIClipboardItem*)) diodon_file_clipboard_item_real_get_checksum;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	iface->to_clipboard = (void (*)(DiodonIClipboardItem*, GtkClipboard*)) diodon_file_clipboard_item_real_to_clipboard;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	iface->equals = (gboolean (*)(DiodonIClipboardItem*, DiodonIClipboardItem*)) diodon_file_clipboard_item_real_equals;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	iface->hash = (guint (*)(DiodonIClipboardItem*)) diodon_file_clipboard_item_real_hash;
#line 2114 "file-clipboard-item.c"
}


static void diodon_file_clipboard_item_instance_init (DiodonFileClipboardItem * self) {
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	self->priv = DIODON_FILE_CLIPBOARD_ITEM_GET_PRIVATE (self);
#line 2121 "file-clipboard-item.c"
}


static void diodon_file_clipboard_item_finalize (GObject* obj) {
	DiodonFileClipboardItem * self;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIODON_TYPE_FILE_CLIPBOARD_ITEM, DiodonFileClipboardItem);
#line 37 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_g_free0 (self->priv->_paths);
#line 38 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_g_free0 (self->priv->_origin);
#line 40 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	_g_date_time_unref0 (self->priv->_date_copied);
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/file-clipboard-item.vala"
	G_OBJECT_CLASS (diodon_file_clipboard_item_parent_class)->finalize (obj);
#line 2137 "file-clipboard-item.c"
}


/**
     * Represents a file clipboard item holding a path to a file.
     */
GType diodon_file_clipboard_item_get_type (void) {
	static volatile gsize diodon_file_clipboard_item_type_id__volatile = 0;
	if (g_once_init_enter (&diodon_file_clipboard_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DiodonFileClipboardItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diodon_file_clipboard_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DiodonFileClipboardItem), 0, (GInstanceInitFunc) diodon_file_clipboard_item_instance_init, NULL };
		static const GInterfaceInfo diodon_iclipboard_item_info = { (GInterfaceInitFunc) diodon_file_clipboard_item_diodon_iclipboard_item_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType diodon_file_clipboard_item_type_id;
		diodon_file_clipboard_item_type_id = g_type_register_static (G_TYPE_OBJECT, "DiodonFileClipboardItem", &g_define_type_info, 0);
		g_type_add_interface_static (diodon_file_clipboard_item_type_id, DIODON_TYPE_ICLIPBOARD_ITEM, &diodon_iclipboard_item_info);
		g_once_init_leave (&diodon_file_clipboard_item_type_id__volatile, diodon_file_clipboard_item_type_id);
	}
	return diodon_file_clipboard_item_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



